Name:		horde
Version:	3.1.7
Release:	2%{?dist}
Summary:	The common Horde Framework for all Horde applications

Source0:	ftp://ftp.horde.org/pub/horde/tarballs/horde-%{version}.tar.gz
Source1:	registry.php
Group:		Applications/Internet
License:	LGPLv2+
URL:		http://www.horde.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch

Requires:	php >= 4.3.0
Requires:	php-xml
Requires:	php-pear(DB)
Requires:	php-pear(File)
Requires:	php-pear(Log)
Requires:	php-pear(Mail_Mime)
Requires:	php-pear(Mail_mimeDecode)
Requires(post):	/sbin/service
Requires(postun):	/sbin/service

%description
The Horde Framework provides a common structure and interface for Horde
applications (such as IMP, a web-based mail program). This RPM is
required for all other Horde module RPMs.

The Horde Project writes web applications in PHP and releases them under
Open Source licenses. For more information (including help with Horde
and its modules) please visit http://www.horde.org/.

READ %{_docdir}/%{name}-%{version}/README.Fedora AFTER INSTALLING FOR
INSTRUCTIONS AND SECURITY!

For additional functionality, also install horde-enhanced

%prep
%setup -q -n %{name}-%{version}

for file in `find lib/ -name '*.php'`; do
	chmod -x $file
done

cat <<_EOF_ >README.Fedora
If Apache is running, you must now configure this installation of Horde by visiting:
http://127.0.0.1/horde/
and then navigating to Administration > Setup > Horde

Documentation on configuring Horde can be found at:
%{_docdir}/%{name}-%{version}/docs/INSTALL

**IMPORTANT** By default, everyone accessing Horde is automatically logged in as
'Administrator'. This is a security risk! It is very important that you change the
authentication backend under the 'Authentication' tab.  For this reason, Horde is
currently only accessible from localhost. To enable wider access, edit:
%{_sysconfdir}/httpd/conf.d/%{name}.conf

Notice: Cookies will not be stored by your browser if you don't use a FQDN (fully
qualified domain name), e.g. http://localhost/horde/.  This will break horde's
sessions and could result in crashing your browser!  Take care to only access horde
via IP address or FQDN (like http://localhost.localdomain/horde/)

Most Horde sites will want to configure a database backend for user preferences
and other horde metadata.  In order to configure such a backend, be sure you
install the appropriate php database module (such as php-mysql or php-pgsql).
Then, follow the instructions in %{_datadir}/%{name}/scripts/sql/README to
import the DB schema.

The following actions are also highly recommended:
	- Install 'horde-enhanced' which contains the following packages:
		php-imap
		php-mbstring
		php-mcrypt
		php-pecl-Fileinfo
		php-pear-Auth-SASL
		php-pear-Date
		php-pear-HTTP-Request
		php-pear-Mail
		php-pear-Net-Socket
		php-pear-Net-SMTP
	(or install them individually)
	- Increase memory_limit in %{_sysconfdir}/httpd/conf.d/%{name}.conf to 32M or higher
	- Browse http://127.0.0.1/horde/test.php for additional suggestions

_EOF_

%build
# Replace #!/usr/local/bin/php with #!/usr/bin/php
for d in scripts/*.php scripts/crond; do
	perl -i -pe 's|^#!/usr/local/bin/php|#!/usr/bin/php|' "$d"
done


%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_datadir}/%{name}
# Copy eveything... except config and docs
cp -a * %{buildroot}%{_datadir}/%{name}
rm -rf %{buildroot}%{_datadir}/%{name}/config/
rm -rf %{buildroot}%{_datadir}/%{name}/docs
rm %{buildroot}%{_datadir}/%{name}/COPYING
rm %{buildroot}%{_datadir}/%{name}/README*

# Copy locale *.mo files into /usr/share/locale
for lang in %{buildroot}%{_datadir}/%{name}/locale/*; do
	mkdir -p %{buildroot}%{_datadir}/locale/`basename $lang`/LC_MESSAGES
	if [ -f $lang/LC_MESSAGES/*.mo ]; then
		for file in $lang/LC_MESSAGES/*.mo; do
			cp -a $file %{buildroot}%{_datadir}/locale/`basename $lang`/LC_MESSAGES/
		done
	fi
done
%find_lang %{name}

install -m 0770 -d %{buildroot}%{_sysconfdir}/%{name}
cp -a config/* %{buildroot}%{_sysconfdir}/%{name}
ln -fs ../../..%{_sysconfdir}/%{name} %{buildroot}%{_datadir}/%{name}/config

# Create default config files
pushd %{buildroot}%{_sysconfdir}/%{name}
rm -f hooks.php.dist
for d in *.dist; do
	d0=`basename $d .dist`
	if [ ! -f "$d0" ]; then
		cp -p $d $d0
	fi
done
cp -a %{SOURCE1} .
popd

cat <<_EOF_ >%{name}.conf
#
# %{summary}
#

Alias /%{name} %{_datadir}/%{name}

<Directory %{_datadir}/%{name}>
	# Comment out the following 3 lines to make Horde accessible from anywhere
	Order Deny,Allow
	Deny from all
	Allow from 127.0.0.1

	Options +FollowSymLinks

	# horde.org's recommended PHP settings:
	php_admin_flag safe_mode off
	php_admin_flag magic_quotes_runtime off
	php_flag session.use_trans_sid off
	php_flag session.auto_start off
	php_admin_flag file_uploads on
	# Optional - required for weather block in Horde to function
	#php_admin_flag allow_url_fopen on

	# If horde dies while trying to handle large email file attachments,
	#  you are probably hitting PHP's memory limit.  Raise that limit here,
	#  but use caution
	# Set to your preference - memory_limit should be at least 32M
	#  and be greater than the value set for post_max_size
	#php_value memory_limit 32M
	#php_value post_max_size 20M
	#php_value upload_max_filesize 10M

	# /usr/share/pear is needed for PEAR. /var/www/html/horde is needed for Horde itself
	# TODO: Set an appropriate include_path, too. Might even increase speed a bit.
	php_admin_value open_basedir "%{_datadir}/%{name}:%{_sysconfdir}/%{name}:/usr/share/pear:/tmp"
	php_admin_flag register_globals off
</Directory>

<Directory %{_sysconfdir}/%{name}>
	Order Deny,Allow
	Deny from all
</Directory>

# Deny access to files that are not served directly by the webserver
<DirectoryMatch "^%{_datadir}/%{name}/(.*/)?(config|lib|locale|po|scripts|templates)/(.*)?">
	Order Deny,Allow
	Deny from all
</DirectoryMatch>

# Deny access to the test.php files except from localhost
<LocationMatch "^/horde/(.*/)?test.php">
	Order Deny,Allow
	Deny from all
	Allow from 127.0.0.1
</LocationMatch>

_EOF_

install -D -p -m 0644 %{name}.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

%clean
rm -rf %{buildroot}

%post
/sbin/service httpd condrestart > /dev/null 2>&1 || :

%postun
/sbin/service httpd condrestart > /dev/null 2>&1 || :

%files -f %{name}.lang
%defattr(-,root,root)
# Apache horde.conf file
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%{_datadir}/%{name}

%doc docs/
%doc COPYING
%doc README
%doc README.Fedora
# Mark configuration files with %config and use secure permissions
# (note that .dist and .xml files are not user-edited and may change each
#	release, so we don't mark noreplace)

%attr(0770,apache,apache) %config %dir %{_sysconfdir}/%{name}
%attr(0640,apache,apache) %config %{_sysconfdir}/%{name}/*.dist
%attr(0660,apache,apache) %config(noreplace) %{_sysconfdir}/%{name}/*.php
%attr(0660,apache,apache) %config %{_sysconfdir}/%{name}/*.xml

%package enhanced
Summary:	Adds extra functionality to the horde framework
Group:		Applications/Internet
BuildArch:	noarch

Requires:	%{name}
Requires:	php-imap
Requires:	php-mbstring
Requires:	php-mcrypt
Requires:	php-pecl(Fileinfo)
Requires:	php-pear(Auth_SASL)
Requires:	php-pear(Date)
Requires:	php-pear(HTTP_Request)
Requires:	php-pear(Mail)
Requires:	php-pear(Net_Socket)
Requires:	php-pear(Net_SMTP)

%description enhanced
A collection of other external packages that extend the horde framework,
including:
	php-imap
	php-mbstring
	php-mcrypt
	php-pecl-Fileinfo
	php-pear-Auth-SASL
	php-pear-Date
	php-pear-HTTP-Request
	php-pear-Mail
	php-pear-Net-Socket
	php-pear-Net-SMTP

%files enhanced
%doc README.Fedora

%changelog
* Thu Apr  3 2008 Brandon Holbrook <fedora at theholbrooks.org> 3.1.7-2
- Now requires php-pear-Mail-mimeDecode

* Sat Mar 8 2008 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk> 3.1.7-1
- Update to 3.1.7
- Lincese tag update

* Mon Jan 11 2008 Brandon Holbrook <fedora at theholbrooks.org> 3.1.6-1
- Update to 3.1.6

* Sat Oct 20 2007 Brandon Holbrook <fedora at theholbrooks.org> 3.1.5-1
- Update to 3.1.5

* Mon Mar 19 2007 Brandon Holbrook <fedora at theholbrooks.org> 3.1.4-2
- Fix webroot to '/horde' in registry.php
	(Horde's webroot auto-detection doesn't work with our config files under /etc)

* Wed Mar 14 2007 Brandon Holbrook <fedora at theholbrooks.org> 3.1.4-1
- Bumped to upstream 3.1.4
- Made jeta 'active' in registry.php since it is no longer beta

* Wed Dec 27 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-11
- created the 'enhanced' subpackage to pull in extented deps

* Wed Dec 27 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-10
- Remove execute permission from all php scripts under horde/lib/
- Make /usr/share/horde/config/ symlink relative
- Don't echo anything in %%post

* Thu Dec 21 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-9
- Change $fileroot to FEDORA_FILEROOT in registry.php
- Warned users about accessing horde via http://localhost/

* Wed Dec 20 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-8
- Add httpd conf entries to make horde more secure
- Require PEAR modules by name rather than RPM name
- Pull in ALL files in /usr/share/horde
- Add recommended actions to README.Fedora

* Wed Dec 13 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-7
- Fix path typo to README.Fedora

* Wed Dec 13 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-6
- Removed dependency on php_database
- Added dependency on php-pear-File
- Created README.Fedora instead of spamming the RPM install

* Thu Nov  2 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-5
- Added FollowSymLinks and some php_admin_flag's to Apache's conf
- Removed (noreplace) from *.xml config files

* Wed Sep 13 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-4
- Handle locales better with %%find_lang

* Sun Sep 10 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.3-3
- Bumped to 3.1.2
- Fixed package names in Requires
- Better inclusion of %%doc files

* Sun Jul  5 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.2-1.1
- Bumped to 3.1.2

* Sun Jun 25 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-9.10
- Added dependencies: php-xml php-pear-DB php-pear-Mail_Mime php-pear-Log

* Sun Jun 25 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-9.9
- Created post-install message to instruct user on further configuration
- Moved /var/lib/horde to /etc/horde (makes more sense)

* Sat Apr 15 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-9.7
- Added custom registry.php
- Killed .htaccess file

* Sat Apr 15 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-9
- Added (noreplace) to all config files

* Sat Apr 15 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-8
- Added perl commands to tidy up Horde's ugly code

* Sat Apr 15 2006 Brandon Holbrook <fedora at theholbrooks.org> 3.1.1-2
- Migrated to Fedora Extras

* Tue Apr 11 2006 Johnny Hughes <johnny@centos.org> 3.1.1-1.c4
- upgraded to upstream version 3.1.1.
- Removed html.php.patch

* Wed Dec 14 2005 Johnny Hughes <johnny@centos.org> 3.0.8-2.centos4
- rolled in html.php.patch to fix this bug:
	http://bugs.horde.org/ticket/?id=3123

* Mon Dec 12 2005 Johnny Hughes <johnny@centos.org> 3.0.8-1.centos4
- Rolled in the upstream changes to version 3.0.8
	See this link: http://marc.theaimsgroup.com/?l=horde-announce&m=113432948731152&w=2

* Tue Nov 29 2005 Johnny Hughes <johnny@centos.org> 3.0.7-1.centos4
- Rolled in upstream changes to version 3.0.7

* Sat Oct 29 2005 Johnny Hughes <johnny@centos.org> 3.0.6-1.centos4
- Initial build for CentOS4
- Changed the html location to be consistent w/CentOS web apps (/usr/share)
- Changed the config file to be in /etc/httpd/conf.d/

* Thu Mar 31 2005 Greg Swallow <gregswallow@skynetonline.ca>
- 3.0.4-1sme01
- Update for Horde 3.0.4 on SME7

* Tue Aug 10 2004 Shad L. Lords <slords@mail.com>
- 2.2.1-2sme01
- Update specfile - change apache to httpd in requires

* Wed Apr 23 2003 Gordon Rowell <gordon_rowell@mitel.com>
- 2.2.1-1es00
- Rebuild [gordonr 7694]

* Tue Feb 25 2003 Dan Brown <dan@familybrown.org>
- 2.2.1-1es
- Rebuilt with horde 2.2.1

* Mon Jul  1 2002 Dan Brown <dan@familybrown.org>
- 2.1 release 1es
- changed apache user and web root to comply with SME Server
- removed horde.conf file, as this information is in e-smith-horde RPM

* Tue Jun 25 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 3

* Mon Jun 24 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 2 (private beta)

* Thu Jun 13 2002 Brent J. Nordquist <bjn@horde.org>
- 2.1 release 1 (private beta)

* Wed Jan 02 2002 Brent J. Nordquist <bjn@horde.org>
- 2.0 release 1

* Mon Dec 24 2001 Brent J. Nordquist <bjn@horde.org>
- 2.0-RC4 release 1

* Sat Dec 15 2001 Brent J. Nordquist <bjn@horde.org>
- rewritten for Horde 2.0

* Wed Nov 14 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.7 release 1rh7

* Sat Jul 21 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.6 release 1rh7

* Tue Feb 06 2001 Brent J. Nordquist <bjn@horde.org>
- 1.2.4 release 1rh
